<template>
  <div class="app-container">
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['qw:appContactWay:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['qw:appContactWay:remove']"
        >删除</el-button>
      </el-col>
    </el-row>

    <el-table border v-loading="loading" :data="appContactWayList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="名称" align="center" prop="name" />
      <el-table-column label="状态" align="center" prop="status">
        <template slot-scope="scope">
          <dict-tag :options="statusOptions" :value="scope.row.status"/>
        </template>
      </el-table-column>
      <el-table-column label="企微主体" align="center" prop="corpName" />
      <el-table-column label="创建时间" align="center" prop="createTime" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            v-if="scope.row.status == 0"
            @click="handleDelete(scope.row)"
            v-hasPermi="['qw:appContactWay:remove']"
          >删除</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['qw:appContactWay:edit']"
          >修改</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改app客服活码上架对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="600px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px" style="margin-top:10px;">
        <el-form-item label="活码名称" prop="name">
          <el-input v-model="form.name" placeholder="请输入活码名称" />
        </el-form-item>
        <el-form-item label="企微主体" prop="corpId">
          <el-select v-model="form.corpId" placeholder="企微账号"  size="small" @change="updateCorpId()">
            <el-option
              v-for="dict in myQwCompanyList"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="员工选择" prop="qwUserIds"  style="height: 50px;">
          <el-select v-model="qwUserIds" remote multiple placeholder="请选择" filterable  style="width: 100%;">
            <el-option
              v-for="dict in companyUserList"
              :key="dict.qwUserId"
              :label="dict.qwUserName"
              :value="dict.qwUserId">
            </el-option>
          </el-select>
        </el-form-item>

      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <el-dialog :title="contactWay.title" :visible.sync="contactWay.open" width="800px" append-to-body >
      <contactWay ref="contactWay" @selectWay="selectWay" ></contactWay>
    </el-dialog>
  </div>
</template>

<script>
import { listAppContactWay, getAppContactWay, delAppContactWay, addAppContactWay, updateAppContactWay, exportAppContactWay } from "@/api/qw/appContactWay";
import ImageUpload from '@/views/qw/material/ImageUpload.vue'
import contactWay from '@/views/qw/appContactWay/contactWay.vue'
import { getMyQwCompanyList } from '@/api/qw/user'
import { getQwAllUserList } from '@/api/company/companyUser'
import { listTag } from '@/api/qw/tag'
import { allListTagGroup } from '@/api/qw/tagGroup'
export default {
  name: "AppContactWay",
  components: { ImageUpload,contactWay },
  data() {
    return {
      qwUserIds:[],
      companyUserList:[],
      myQwCompanyList:[],
      statusOptions:[],
      orOptions:[],
      contactWay:{
        title:"",
        open:false
      },
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // app客服活码上架表格数据
      appContactWayList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        imgUrl: null,
        companyId: null,
        status: null,
        name:null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        name:[{required:true,message:"名称不能为空",trigger:"blur"}],
        corpId:[{required:true,message:"主体不能为空",trigger:"blur"}],
        // qwUserIds:[{required:true,message:"员工不能为空",trigger:"blur"}]
      }
    };
  },
  created() {
    this.getList();
    this.getDicts("sys_spec_show").then(response => {
      this.statusOptions = response.data;
    });
    getMyQwCompanyList().then(response => {
      this.myQwCompanyList = response.data;
    });
  },
  methods: {
    updateCorpId(){
      const selectedCompany = this.myQwCompanyList.find(company => company.dictValue === this.form.corpId);

      // 如果找到匹配的选项，则更新 form.corpName
      if (selectedCompany) {
        this.form.corpName = selectedCompany.dictLabel;
      } else {
        this.form.corpName = null; // 可根据需求处理未找到匹配项的情况
      }
      this.companyUserList=[];
      this.qwUserIds=[];
      getQwAllUserList(this.form.corpId).then(response => {
        this.companyUserList = response.data;
      });
    },
    selectWay(row){
      this.form = {};
      this.form.name=row.name;
      this.form.imgUrl=row.qrCode;
      this.$message({
        message: '添加成功',
        type: 'success'
      });
      this.contactWay.open = false;
    },
    chooseWay(){
      this.contactWay.open = true;
      this.contactWay.title="选择活码"
    },
    /** 查询app客服活码上架列表 */
    getList() {
      this.loading = true;
      listAppContactWay(this.queryParams).then(response => {
        this.appContactWayList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        corpId:null,
        corpName:null,
        qwUserIds:null,
        createTime: null,
        updateTime: null,
        companyId: null,
        status: 0
      };
      this.qwUserIds=[];
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加app客服活码上架";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getAppContactWay(id).then(response => {
        this.form = response.data;
        getQwAllUserList(this.form.corpId).then(response => {
          this.companyUserList = response.data;
        });
        if (response.data.qwUserIds!=null){
          this.qwUserIds = this.form.qwUserIds.split(",");
        }
        this.open = true;
        this.title = "修改app客服活码上架";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.form.qwUserIds = this.qwUserIds.toString()
          if (this.form.id != null) {
            updateAppContactWay(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addAppContactWay(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除app客服活码上架编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delAppContactWay(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有app客服活码上架数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportAppContactWay(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
